; Lab 1
; written by S. Barnicki
;
; March 1999
;

	.globl  write_string    ;declare routine external
	.globl wait
	
	.area ports (abs)
ddrc    = 0x1007        ;data direction register for C
pioc    = 0x1002        ;for strobe B assertion change
portcl  = 0x1005        ;port C latched
portb   = 0x1004        ;port B

; set area for stack
	.area STACK (rel,con)
	.blkb 256       ;stack area
stckhi::                ;initial stack pointer value


; set area for code
	.area CODE (rel,con)
write_string::

	lds  #stckhi    ;set initial stack pointer value
	ldaa #0xFF      ;set for output
	staa ddrc       ;C output
	ldaa pioc       ;get current value
	anda #0xFE      ;reset bit 0 to 0
	staa pioc       ;send it out

	ldx  #string    ;get the string address
	ldab #0x4       ;position value

print:  ldaa 0,x        ;get a value
	cmpa #0         ;is it a null?
	beq  end        ;done
	cmpb #0         ;off the end?
	bne  ok
	ldab #0x4       ;reset to 4
	dex
	dex
	dex             ;move pointer back
	jsr  wait
	bra  print      ;keep going

ok:     decb            ;position = position - 1
	stab portcl     ;set the position 
	staa portb      ;set the character
	inx             ;point to next one
	bra  print      ;keep going

	.area CODE (rel,con)
; subroutine wait
; waits 250 ms
; modifies nothing
wait::   psha            ;save A
	tpa             ;save condition codes
	psha
	pshx
	ldx #250        ;wait 250 milliseconds
1$:     jsr wait1ms     ;local label
	dex
	bne 1$
	pulx
	pula
	tap
	pula
	rts

wait1ms:psha            ;1 ms wait
	tpa
	psha
	pshx
	ldx #200
2$:     dex
	nop
	nop
	bne 2$
	pulx
	pula
	tap
	pula
	rts

end::   bra end

;
;data here
;
	.area DATA (rel,con)
string: .asciz "HELLO, IT WORKS!"       ;null terminated string



